#include <iostream>
#include <thread>

#include "../include/Server.h"
#include "../include/Sniffer.h"
#include "../include/user_manager.h"

using namespace std;

int main(int argc, char *argv[]) {
  if (argc < 2) {
    cout << "Usage: " << argv[0] << " <interface>" << endl << endl;
    return 0;
  }

  // check if userStorage is add specified location
  // if not create one
  UserManager::init();

  const string interface = argv[1];
  Sniffer *sniffer = new Sniffer(interface);
  thread snifferThread(&Sniffer::startSniffing, sniffer);

  try {
    io_service io_service;
    Server server(io_service);
    io_service.run();
  } catch (exception &e) {
    cerr << e.what() << endl;
  }

  snifferThread.join();
  delete (sniffer);
  return 0;
}
